Index: s390-tools-sles11/ziomon/ziomon_dacc.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_dacc.c
+++ s390-tools-sles11/ziomon/ziomon_dacc.c
@@ -10,27 +10,25 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <time.h>
+#include <string.h>
+#include <unistd.h>
+#include <assert.h>
 
 #include "ziomon_dacc.h"
 #include "ziomon_util.h"
 #include "ziomon_msg_tools.h"
 
 
-#define ZIOMON_DACC_NAME	"ziomon_dacc"
-
 #define ZIOMON_DACC_GARBAGE_MSG	-1
 
+extern const char *toolname;
 extern int verbose;
-#define vverbose_msg(x...)	do {\
-					if (verbose >= 2)\
-						printf("\t===     " x);\
-				} while (0)
 
 /*
  * Structure of binary file:
  *                                                                          |
  * +-----+---+---+-----+---+---+---------+---+---+---------+-      -+-----+ |
- * | hdr | l | t | msg | l | t |   msg   | l | t |   msg   |        | msg | |
+ * | hdr | l | t | dat | l | t |   dat   | l | t |   dat   |        | dat | |
  * +-----+---+---+-----+---+---+---------+---+---+---------+- .... -+-----+ |
  *                                                                          |
  *                                                                        limit
@@ -40,17 +38,27 @@ extern int verbose;
  * around, overwriting old messages. Hence it is utterly important that we keep
  * the lengths 'l' intact, since we will have random garbage after one of the
  * messages once we wrapped around for the first time.
- * The length is specified as __s32 and specifies the length of the variable
+ * 't' denotes the type of the message, 'dat' is the (variable length) data.
+ * The length is specified as __u32 and specifies the length of the variable
  * part of the message entry, beginning after the message type.
  * 'length' will always specify the length of the variable part of the message
  *
  * Aggregated statistics are put into a separate file.
  * Messages inside the aggregated file are written in fixed order (so we do not
  * need struct file_header to figure out what is where).
- * Note that we write a single garbage messages for any message that might have
+ * Note that we write a single garbage message for any message that might have
  * not been used yet!
  */
 
+
+/* indicates whether we already wrapped or not */
+static int wrapped = -1;
+
+#ifndef NDEBUG
+static int open_count = 0;
+#endif
+
+
 /**
  * Calculate size of the message. In contrast to the message's
  * length attribute, this also includes the header */
@@ -59,11 +67,12 @@ static int get_total_msg_size(struct mes
 }
 
 
+/**
+ * Position at first _physical_ message, not necessarily the first
+ * logical message */
 static int position_at_first_msg(FILE * fp)
 {
-	fseek(fp, sizeof(struct file_header), SEEK_SET);
-
-	return 0;
+	return fseek(fp, sizeof(struct file_header) - sizeof(__u64), SEEK_SET);
 }
 
 
@@ -79,6 +88,7 @@ static void swap_header(struct file_head
 	swap_32(f_hdr->msgid_zfcpdd);
 	swap_64(f_hdr->end_time);
 	swap_64(f_hdr->first_msg_offset);
+	swap_64(f_hdr->begin_time);
 }
 
 
@@ -95,9 +105,10 @@ static int write_f_header(FILE *fp, stru
 
 	rewind(fp);
 	swap_header(f_hdr);
-	if (fwrite(f_hdr, sizeof(struct file_header), 1, fp) != 1) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Failed to write"
-			" header\n");
+	if (fwrite(f_hdr, sizeof(struct file_header)
+		   - sizeof(__u64), 1, fp) != 1) {
+		fprintf(stderr, "%s: Failed to write"
+			" header\n", toolname);
 		rc = -1;
 	}
 	swap_header(f_hdr);
@@ -121,8 +132,8 @@ static int write_garbage_message(FILE *f
 
 	swap_msg_header(&msg);
 	if (!fwrite(&msg, 8, 1, fp)) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Error writing"
-			" garbage\n");
+		fprintf(stderr, "%s: Error writing"
+			" garbage\n", toolname);
 		return -1;
 	}
 
@@ -130,27 +141,42 @@ static int write_garbage_message(FILE *f
 }
 
 
-static int read_message(FILE *fp, struct message *msg)
+static int read_message_header(FILE *fp, __u32 *length, __u32 *type)
 {
+#ifndef NDEBUG
 	long pos = ftell(fp);
+#endif
 
-	if (fread(&msg->length, 4, 1, fp) != 1) {
+	if (fread(length, 4, 1, fp) != 1) {
 		if (feof(fp))
 			return 1;	/* end of file reached */
 		else {
-			fprintf(stderr, ZIOMON_DACC_NAME ": Error reading"
-				" message length\n");
+			fprintf(stderr, "%s: Error reading"
+				" message length\n", toolname);
 			return -1;
 		}
 	}
-	if (fread(&msg->type, 4, 1, fp) != 1) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Error reading message"
-			" type\n");
+	if (fread(type, 4, 1, fp) != 1) {
+		fprintf(stderr, "%s: Error reading message"
+			" type\n", toolname);
 		return -1;
 	}
-	swap_msg_header(msg);
-	vverbose_msg("read %smsg at pos=%ld, total size=%d\n",
-		     (msg->type == ZIOMON_DACC_GARBAGE_MSG ? "garbage " : ""), pos, get_total_msg_size(msg));
+	swap_32(*type);
+	swap_32(*length);
+
+	vverbose_msg("read %smsg at pos=%ld, data size=%d\n",
+		     (*type == ZIOMON_DACC_GARBAGE_MSG ? "garbage " : ""), pos, *length);
+
+	return 0;
+}
+
+
+static int read_message(FILE *fp, struct message *msg)
+{
+	int rc;
+
+	if ( (rc = read_message_header(fp, &msg->length, &msg->type)) )
+		return rc;
 
 	if (msg->type == ZIOMON_DACC_GARBAGE_MSG) {
 		fseek(fp, msg->length, SEEK_CUR);
@@ -159,8 +185,8 @@ static int read_message(FILE *fp, struct
 	else {
 		msg->data = malloc(msg->length);
 		if (fread(msg->data, msg->length, 1, fp) != 1) {
-			fprintf(stderr, ZIOMON_DACC_NAME ": Error reading"
-				" message content\n");
+			fprintf(stderr, "%s: Error reading %u Bytes message"
+				" content\n", toolname, msg->length);
 			return -1;
 		}
 	}
@@ -169,6 +195,34 @@ static int read_message(FILE *fp, struct
 }
 
 
+static int read_message_preview(FILE *fp, struct message_preview *msg)
+{
+	int rc;
+
+	msg->pos = ftell(fp);
+	if ( (rc = read_message_header(fp, &msg->length, &msg->type)) )
+		return rc;
+
+	/* Eventually read timestamp and fforward to next msg */
+	if (msg->type != ZIOMON_DACC_GARBAGE_MSG) {
+		/* per convention, the first 8 bytes of the actual message
+		 * is the timestamp. */
+		assert(msg->length >= 8);
+		if (fread(&msg->timestamp, 8, 1, fp) != 1) {
+			fprintf(stderr, "%s: Error reading"
+				" message timestamp\n", toolname);
+			return -1;
+		}
+		swap_64(msg->timestamp);
+		fseek(fp, msg->length - 8, SEEK_CUR);
+	}
+	else
+		fseek(fp, msg->length, SEEK_CUR);
+
+	return 0;
+}
+
+
 /**
  * Add msg to the bunch of aggregated messages.
  */
@@ -283,7 +337,7 @@ static __s32 position_in_file(FILE *fp, 
 	}
 	if (cum_size - get_total_msg_size(msg) > 0
 	    && cum_size - get_total_msg_size(msg) < 8) {
-		/* garbage message required, but even minimum size 
+		/* garbage message required, but even minimum size
 		   would overwrite start of next msg - aggregate one more! */
 		if (get_next_msg_size(fp, &next_msg_length)) {
 			/* corner case: we are at EOF, but our message
@@ -313,21 +367,21 @@ static int write_message(FILE *fp, struc
 		     get_total_msg_size(msg));
 	swap_msg_header(msg);
 	if (!fwrite(&msg->length, 4, 1, fp)) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Writing of length"
-			" failed\n");
+		fprintf(stderr, "%s: Writing of length"
+			" failed\n", toolname);
 		swap_msg_header(msg);
 		return -1;
 	}
 	if (!fwrite(&msg->type, 4, 1, fp)) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Writing of type failed\n");
+		fprintf(stderr, "%s: Writing of type failed\n", toolname);
 		swap_msg_header(msg);
 		return -2;
 	}
 	swap_msg_header(msg);
 
 	if (!fwrite(msg->data, msg->length, 1, fp)) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Writing of message data"
-			" failed\n");
+		fprintf(stderr, "%s: Writing of message data"
+			" failed\n", toolname);
 		return -3;
 	}
 
@@ -375,72 +429,92 @@ int init_file(FILE *fp, struct file_head
 	f_hdr->version = DATA_MGR_V2;
 	f_hdr->first_msg_offset = 0;
 	f_hdr->end_time = 0;
+	f_hdr->begin_time = 0;
 
 	if (write_f_header(fp, f_hdr))
 		return -1;
-/*	if (position_at_first_msg(fp))
-		return -1;*/
 
 	return 0;
 }
 
-int get_header(FILE *fp, struct file_header *hdr)
+
+static int get_header(FILE *fp, struct file_header *hdr)
 {
 	rewind(fp);
-	if (fread(hdr, sizeof(struct file_header), 1, fp) != 1) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Could not read header\n");
+	if (fread(hdr, sizeof(struct file_header)
+		  - sizeof(__u64), 1, fp) != 1) {
+		fprintf(stderr, "%s: Could not read header\n", toolname);
 		return -1;
 	}
 	swap_header(hdr);
 	if (hdr->magic != DATA_MGR_MAGIC) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": No valid header\n");
+		fprintf(stderr, "%s: Unregocgnized data in .log file.\n",
+			toolname);
 		return -2;
 	}
 	if (hdr->version != DATA_MGR_V2) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Wrong version\n");
+		fprintf(stderr, "%s: Wrong version: .log data is in version %u"
+			" format, while this tool only supports version %u."
+			" Get the matching tool version and try again.\n",
+			toolname, hdr->version, DATA_MGR_V2);
 		return -2;
 	}
+	hdr->begin_time = 0;
 
 	return 0;
 }
 
 
-int get_next_msg(FILE *fp, struct message *msg, struct file_header *f_hdr)
+int open_log_file(FILE **fp, const char *filename, struct file_header *fhdr)
 {
-	int rc;
-	static long pos = 0;
-	static int wrapped = 0;
-
-	if (pos == 0) {
-		if (f_hdr->first_msg_offset)
-			pos = f_hdr->first_msg_offset;
-		else {
-			pos = sizeof(struct file_header);
-			wrapped++;	/* no need to wrap */
-		}
-		fseek(fp, pos, SEEK_SET);
-	}
+	int rc = 0;
+	char *fname = NULL;
+	struct message_preview msg_prev;
 
-	do {
-		rc = read_message(fp, msg);
-		if (rc > 0 && !wrapped) {
-			position_at_first_msg(fp);
-			rc = read_message(fp, msg);
-			wrapped++;
-		}
-	} while (!rc && msg->type == ZIOMON_DACC_GARBAGE_MSG);
+	fname = (char*)malloc(strlen(filename) + strlen(DACC_FILE_EXT_LOG) + 1);
+	sprintf(fname, "%s%s", filename, DACC_FILE_EXT_LOG);
+	*fp = fopen(fname, "r");
+	if (!*fp) {
+		fprintf(stderr, "%s: Could not open %s"
+			" - file not accessible?", toolname, fname);
+		rc = 1;
+		goto out;
+	}
+	if (get_header(*fp, fhdr)) {
+		rc = -2;
+		goto out;
+	}
+	if (get_next_msg_preview(*fp, &msg_prev, fhdr)) {
+		rc = -3;
+		goto out;
+	}
+	rewind_to(*fp, &msg_prev);
+	fhdr->begin_time = msg_prev.timestamp;
+
+out:
+	free(fname);
+	if (rc < 0)
+		fclose(*fp);
 
 	return rc;
 }
 
 
-void discard_msg(struct message *msg)
+void close_log_file(FILE *fp)
 {
-	if (msg) {
-		free(msg->data);
-		msg->data = NULL;
+	wrapped = -1;
+	if (fp)
+		fclose(fp);
+}
 
-	}
+
+void close_data_files(FILE *fp)
+{
+#ifndef NDEBUG
+	open_count--;
+	assert(open_count == 0);
+#endif
+	close_log_file(fp);
 }
 
 
@@ -448,14 +522,24 @@ static void swap_agg_header(struct aggr_
 {
 	swap_32(hdr->magic);
 	swap_32(hdr->version);
-	swap_64(hdr->timestamp);
+	swap_64(hdr->begin_time);
 	swap_64(hdr->num_zfcpdd);
 	swap_64(hdr->num_blkiomon);
 	swap_64(hdr->end_time);
 }
 
 
-int read_aggr_file(FILE *fp, struct aggr_data *data)
+static void conv_agg_header_from_BE(struct aggr_data *hdr) {
+	swap_agg_header(hdr);
+}
+
+
+static void conv_agg_header_to_BE(struct aggr_data *hdr) {
+	swap_agg_header(hdr);
+}
+
+
+static int read_aggr_file(FILE *fp, struct aggr_data *data)
 {
 	int i;
 	int rc;
@@ -463,15 +547,28 @@ int read_aggr_file(FILE *fp, struct aggr
 
 	rewind(fp);
 	if (fread(data, DACC_AGGR_FILE_HDR_LEN, 1, fp) != 1) {
-		fprintf(stderr, ZIOMON_DACC_NAME ": Error reading aggregation"
-			" content\n");
+		fprintf(stderr, "%s: Error reading aggregation"
+			" content\n", toolname);
+		return -1;
+	}
+	conv_agg_header_from_BE(data);
+	if (data->magic != DATA_MGR_MAGIC_AGGR) {
+		fprintf(stderr, "%s: Unregocgnized data in .agg file.\n",
+			toolname);
+		return -1;
+	}
+	if (data->version != DATA_MGR_V2) {
+		fprintf(stderr, "%s: Wrong version: .agg data is in version %u"
+			" format, while this tool only supports version %u."
+			" Get the matching tool version and try again.\n",
+			toolname, data->version, DATA_MGR_V2);
 		return -1;
 	}
-	swap_agg_header(data);
 
 	data->util_aggr = NULL;
 	if ( (rc = read_message(fp, &msg)) < 0)
 		return -2;
+
 	if (msg.type != ZIOMON_DACC_GARBAGE_MSG) {
 		data->util_aggr = malloc(sizeof(struct message));
 		*(data->util_aggr) = msg;
@@ -521,17 +618,153 @@ int read_aggr_file(FILE *fp, struct aggr
 }
 
 
+int open_agg_file(FILE **fp, const char *filename, struct aggr_data *agg)
+{
+	int rc = 0;
+	char *fname = NULL;
+
+	fname = (char*)malloc(strlen(filename) + strlen(DACC_FILE_EXT_AGG) + 1);
+	sprintf(fname, "%s%s", filename, DACC_FILE_EXT_AGG);
+
+	/* test the water */
+	if (access(fname, F_OK) != 0) {
+		rc = 1;
+		goto out;
+	}
+	*fp = fopen(fname, "r");
+	if (!*fp) {
+		fprintf(stderr, "%s: Could not open %s"
+			" - file not accessible?", toolname, fname);
+		rc = 1;
+		goto out;
+	}
+	if (read_aggr_file(*fp, agg)) {
+		fclose(*fp);
+		rc = -1;
+		goto out;
+	}
+
+out:
+	free(fname);
+
+	return rc;
+}
+
+
+void close_agg_file(FILE *fp)
+{
+	if (fp)
+		fclose(fp);
+}
+
+
+static int seek_initial_file_pos(FILE *fp, struct file_header *f_hdr)
+{
+	int rc = 0;
+	long pos;
+
+	if (f_hdr->first_msg_offset)
+		pos = f_hdr->first_msg_offset;
+	else {
+		pos = sizeof(struct file_header) - sizeof(__u64);
+		rc = 1;	/* no need to wrap */
+	}
+	fseek(fp, pos, SEEK_SET);
+
+	return rc;
+}
+
+
+int get_next_msg(FILE *fp, struct message *msg, struct file_header *f_hdr)
+{
+	int rc;
+
+	if (wrapped < 0)
+		wrapped = seek_initial_file_pos(fp, f_hdr);
+
+	do {
+		if (f_hdr->first_msg_offset != 0 && wrapped
+		    && ftell(fp) >= f_hdr->first_msg_offset)
+			return 1;	/* final msg read */
+
+		rc = read_message(fp, msg);
+		if (rc > 0 && !wrapped) {
+			position_at_first_msg(fp);
+			rc = read_message(fp, msg);
+			wrapped++;
+		}
+	} while (!rc && msg->type == ZIOMON_DACC_GARBAGE_MSG);
+
+	return rc;
+}
+
+
+int get_next_msg_preview(FILE *fp, struct message_preview *msg,
+			 struct file_header *f_hdr)
+{
+	int rc;
+
+	if (wrapped < 0)
+		wrapped = seek_initial_file_pos(fp, f_hdr);
+
+	do {
+		if (f_hdr->first_msg_offset != 0 && wrapped
+		    && ftell(fp) >= f_hdr->first_msg_offset)
+			return 1;	/* final msg read */
+
+		rc = read_message_preview(fp, msg);
+		if (rc > 0 && !wrapped) {
+			position_at_first_msg(fp);
+			rc = read_message_preview(fp, msg);
+			wrapped++;
+		}
+	} while (!rc && msg->type == ZIOMON_DACC_GARBAGE_MSG);
+
+	return rc;
+}
+
+
+void rewind_to(FILE *fp, struct message_preview *msg)
+{
+	assert(msg->pos > 0);
+	fseek(fp, msg->pos, SEEK_SET);
+}
+
+
+int get_complete_msg(FILE *fp, struct message_preview *msg_prev,
+		     struct message *msg)
+{
+	long pos = ftell(fp);
+	int rc;
+
+	fseek(fp, msg_prev->pos, SEEK_SET);
+	rc = read_message(fp, msg);
+	fseek(fp, pos, SEEK_SET);
+
+	return rc;
+}
+
+
+void discard_msg(struct message *msg)
+{
+	if (msg) {
+		free(msg->data);
+		msg->data = NULL;
+
+	}
+}
+
+
 int write_aggr_file(FILE *fp, struct aggr_data *data)
 {
 	int i;
 
-	swap_agg_header(data);
+	conv_agg_header_to_BE(data);
 	rewind(fp);
-	if (fwrite(data, DACC_AGGR_FILE_HDR_LEN, 1, fp) != 1) {
-		swap_agg_header(data);
+	i = fwrite(data, DACC_AGGR_FILE_HDR_LEN, 1, fp);
+	conv_agg_header_from_BE(data);
+	if (i != 1)
 		return -1;
-	}
-	swap_agg_header(data);
 
 	if (data->util_aggr) {
 		if (write_message(fp, data->util_aggr))
@@ -576,7 +809,7 @@ void init_aggr_data_struct(struct aggr_d
 	data->num_zfcpdd = 0;
 	data->num_blkiomon = 0;
 	data->end_time = 0;
-	data->timestamp = 0;
+	data->begin_time = 0;
 	data->util_aggr = NULL;
 	data->ioerr_aggr = NULL;
 	data->blkio_aggr = NULL;
@@ -588,20 +821,127 @@ void discard_aggr_data_struct(struct agg
 {
 	unsigned int i;
 
-	discard_msg(data->util_aggr);
-	discard_msg(data->ioerr_aggr);
-	for (i=0; i<data->num_blkiomon; ++i) {
-		discard_msg(data->blkio_aggr[i]);
-		free(data->blkio_aggr[i]);
-	}
-	for (i=0; i<data->num_zfcpdd; ++i) {
-		discard_msg(data->zfcpdd_aggr[i]);
-		free(data->zfcpdd_aggr[i]);
-	}
-	free(data->util_aggr);
-	free(data->ioerr_aggr);
-	free(data->blkio_aggr);
-	free(data->zfcpdd_aggr);
+	if (data) {
+		discard_msg(data->util_aggr);
+		discard_msg(data->ioerr_aggr);
+		for (i=0; i<data->num_blkiomon; ++i) {
+			discard_msg(data->blkio_aggr[i]);
+			free(data->blkio_aggr[i]);
+		}
+		for (i=0; i<data->num_zfcpdd; ++i) {
+			discard_msg(data->zfcpdd_aggr[i]);
+			free(data->zfcpdd_aggr[i]);
+		}
+		free(data->util_aggr);
+		free(data->ioerr_aggr);
+		free(data->blkio_aggr);
+		free(data->zfcpdd_aggr);
+	}
+}
+
+
+int open_data_files(FILE **fp, const char *filename, struct file_header *f_hdr,
+	      struct aggr_data **agg)
+{
+	struct message_preview msg_prev;
+	struct message msg;
+	int rc = 0;
+	int i;
+	__u64 end_of_agg;
+	time_t t;
+
+#ifndef NDEBUG
+	assert(open_count == 0);
+	open_count++;
+#endif
+
+	verbose_msg("open data\n");
+
+	/*
+	 * Open .agg file if exists
+	 */
+
+	*agg = (struct aggr_data*)malloc(sizeof(struct aggr_data));
+	if ( (rc = open_agg_file(fp, filename, *agg)) < 0 ) {
+		free(*agg);
+		return -1;
+	}
+	if (rc == 0) {
+		verbose_msg("  found .agg file\n");
+		close_agg_file(*fp);
+	}
+	else {
+		verbose_msg("  no .agg file found\n");
+		free(*agg);
+		*agg = NULL;
+	}
+
+	/*
+	 * Open .log file
+	 */
+	if ( (rc = open_log_file(fp, filename, f_hdr)) )
+		return -1;
+
+	/*
+	 * Eventually add messages from final frame of .agg file and adjust
+	 * respective boundaries
+	 */
+
+	if (*agg) {
+		conv_aggr_data_msg_data_from_BE(*agg);
+
+		/* We use the first message that we have as the basis to
+		   calculate when the final timeframe of the .agg data
+		   would have ended. Note that we always add all messages
+		   that are interval/2 after that timestamp! */
+		end_of_agg = ((*agg)->end_time - (*agg)->begin_time -
+			f_hdr->interval_length / 2) % f_hdr->interval_length;
+		if (end_of_agg)
+			end_of_agg = (*agg)->end_time
+				+ (f_hdr->interval_length - end_of_agg);
+
+		i = 0;
+		while ( (rc = get_next_msg_preview(*fp, &msg_prev, f_hdr)) == 0
+			 && msg_prev.timestamp <= end_of_agg) {
+			if (get_complete_msg(*fp, &msg_prev, &msg))
+			    return -1;
+			rc = add_to_agg(*agg, &msg, f_hdr);
+			discard_msg(&msg);
+			if (rc)
+				return -1;
+			++i;
+		}
+		if (rc < 0) {
+			fprintf(stderr, "%s: Could not read"
+				" any messages in %s%s\n", toolname, filename,
+				DACC_FILE_EXT_LOG);
+			return -1;
+		}
+		// condition of the check impossible to fail, but still...
+		if (msg_prev.timestamp > end_of_agg)
+			rewind_to(*fp, &msg_prev);
+
+		// finally, adjust boundaries
+		(*agg)->end_time = end_of_agg - f_hdr->interval_length / 2;
+		f_hdr->begin_time = (*agg)->end_time + f_hdr->interval_length;
+		if (verbose > 0) {
+			t = (*agg)->end_time;
+			verbose_msg("  adjust agg end time to  : %s",
+				    ctime(&t));
+			t = (*agg)->begin_time;
+			verbose_msg("  adjust log begin time to: %s",
+				    ctime(&t));
+		}
+
+		conv_aggr_data_msg_data_to_BE(*agg);
+		verbose_msg("  added %d messages to aggregated structure\n",
+			    i);
+	}
+
+	verbose_msg("open data finished\n");
+
+	return 0;
 }
 
 
+
Index: s390-tools-sles11/ziomon/ziomon_dacc.h
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_dacc.h
+++ s390-tools-sles11/ziomon/ziomon_dacc.h
@@ -40,6 +40,19 @@ struct message {
 	void   *data;
 } __attribute__ ((packed));
 
+/**
+ * Preview version of a message. Has timestamp included,
+ * but not the actual content.
+ */
+struct message_preview {
+	__u32	length;	/* length of the message in Bytes,
+			   excluding the 'length' and 'type' attributes.
+			   Or, in other word, length of 'data' */
+	__u32	type;
+	__u64   timestamp;
+	long	pos;	/* position in file where msg starts */
+};
+
 #define DACC_FILE_EXT_LOG	".log"
 struct file_header {
 	__u32	magic;
@@ -63,6 +76,16 @@ struct file_header {
 	__u32	msgid_ioerr;
 	__u32	msgid_blkiomon;
 	__u32	msgid_zfcpdd;
+
+	/* NOT WRITTEN TO DISK!!! */
+	/* Since we might move messages from .log to .agg in a round-robin
+	 * fashion, it is not trivial to get the timestamp of the first message
+	 * in .log - each time we write a new message, we would have to read
+	 * the next one and rewind again.
+	 * Hence we figure this one out only when we open a finished .log file,
+	 * but do not actually write it to disk.
+	*/
+	__u64	begin_time;
 } __attribute__ ((packed));
 
 
@@ -71,7 +94,7 @@ struct file_header {
 struct aggr_data {
 	__u32	magic;
 	__u32	version;
-	__u64	timestamp;	/* start time of aggregated data */
+	__u64	begin_time;	/* start time of aggregated data */
 	__u64	end_time;	/* timestamp of latest message */
 	__u64	num_zfcpdd;	/* number of zfcpdd messages */
 	__u64	num_blkiomon;	/* number of blkiomon messages */
@@ -89,6 +112,42 @@ struct aggr_data {
  */
 int init_file(FILE *fp, struct file_header *f_hdr);
 
+
+/**
+ * Open an existing .log file and read its header.
+ * Returns <0 in case of error, >0 if file doesn't exist.
+ * 'filename' is assumed to NOT carry the .log extension.
+ * ONLY USE IF YOU KNOW WHAT YOU DO, i.e. in case you want to access
+ * the as-is data. Anyone else should rather use open_data().
+ * NOTE: Use close_log_file() when finished! */
+int open_log_file(FILE **fp, const char *filename, struct file_header *fhdr);
+
+
+/**
+ * Must be called to close fp and reset internals */
+void close_log_file(FILE *fp);
+
+/**
+ * Open the data files. This function will not only open the .log and .agg
+ * files, but also
+ * - read and aggregate the first few messages from .log in case they are
+ *   missing in the 'agg' data to complete the respective frame.
+ * - adjust the boundaries of both, .log and .agg so that .agg has the
+ *   complete content of the last frame it scratched upon and the next message
+ *   read from .log will be the first message of the first frame not in .agg
+ * Returns <0 in case of error, >0 if file doesn't exist.
+ * 'filename' is assumed to NOT carry the .log or .agg extension.
+ * Note that, consistent with all other API calls, the messages inside 'agg'
+ * are still in BE format!
+ * NOTE: Use close_data_files() when finished! */
+int open_data_files(FILE **fp, const char *filename, struct file_header *fhdr,
+	      struct aggr_data **agg);
+
+
+/**
+ * Must be called to close fp and reset internals */
+void close_data_files(FILE *fp);
+
 /**
  * Put a message into the file. Will automatically wrap around.
  * If existing messages have to be deleted to add the new message,
@@ -102,18 +161,35 @@ int add_msg(FILE *fp, struct message *ms
 	    struct message ***del_msgs, int *num_del_msgs);
 
 /**
- * Retrieve the header information and go to first message.
+ * Retrieve the next message from the file. Note that the returned message has
+ * to be discarded!
+ * Returns 0 if successful, >0 if end of file reached, <0 in case of error.
  * fp is assumed to have been opened.
  */
-int get_header(FILE *fp, struct file_header *hdr);
+int get_next_msg(FILE *fp, struct message *msg, struct file_header *f_hdr);
 
 /**
- * Retrieve the next message from the file. Note that the returned message has
- * to be discarded!
+ * Retrieve preview of next message from the file.
+ * Note that fp will be forwarded to the next message!
+ * If you want the actual message, use get_complete_msg().
+ * If you want to stay at the message, use rewind_to().
  * Returns 0 if successful, >0 if end of file reached, <0 in case of error.
  * fp is assumed to have been opened.
  */
-int get_next_msg(FILE *fp, struct message *msg, struct file_header *f_hdr);
+int get_next_msg_preview(FILE *fp, struct message_preview *msg,
+			 struct file_header *f_hdr);
+
+/**
+ * Rewinds to the start of the provided message preview.
+ * Handy in case you could not process the message preview on the
+ * first time and want to make sure that you read it again next time. */
+void rewind_to(FILE *fp, struct message_preview *msg);
+
+/**
+ * Get complete message for a preview. Rewinds back to where it was at.
+ */
+int get_complete_msg(FILE *fp, struct message_preview *msg_prev,
+		     struct message *msg);
 
 /**
  * Frees the alloc'd portion of a message.
@@ -126,15 +202,22 @@ void discard_msg(struct message *msg);
 void init_aggr_data_struct(struct aggr_data *data);
 
 /**
- * Frees the alloc'd portion of the struct.
- */
-void discard_aggr_data_struct(struct aggr_data *data);
+ * Open an existing .agg file and read its header.
+ * Returns <0 in case of error, >0 if file doesn't exist.
+ * 'filename' is assumed to NOT carry the .log extension.
+ * ONLY USE IF YOU KNOW WHAT YOU DO, i.e. in case you want to access
+ * the as-is data. Anyone else should rather use open_data().
+ * NOTE: Use close_agg_file() when finished! */
+int open_agg_file(FILE **fp, const char *filename, struct aggr_data *agg);
 
 /**
- * Read content of a file holding aggregated data.
- * fp is assumed to have been opened.
+ * Must be called to close fp and reset internals */
+void close_agg_file(FILE *fp);
+
+/**
+ * Frees the alloc'd portion of the struct.
  */
-int read_aggr_file(FILE *fp, struct aggr_data *data);
+void discard_aggr_data_struct(struct aggr_data *data);
 
 /**
  * Write aggregated data to file.
@@ -144,3 +227,4 @@ int write_aggr_file(FILE *fp, struct agg
 
 
 #endif
+
Index: s390-tools-sles11/ziomon/ziomon_fcpconf
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_fcpconf
+++ s390-tools-sles11/ziomon/ziomon_fcpconf
@@ -17,8 +17,8 @@ use File::Spec::Functions;
 use Getopt::Long;
 
 sub version {
-	print "$PROGRAM_NAME: version %S390_TOOLS_VERSION%.\n";
-	print "Copyright IBM Corp. 2008.\n";
+	print "$PROGRAM_NAME: version %S390_TOOLS_VERSION%\n";
+	print "Copyright IBM Corp. 2008\n";
 }
 
 sub usage
@@ -32,7 +32,7 @@ Options:
 
         -h, --help
 		print this help text and exit.
-	
+
 	-v, --version
 		print version information and exit.
 
@@ -84,8 +84,8 @@ system("mkdir -p $temp_dir/sys/devices/v
 system("mkdir -p $temp_dir/sys/class");
 system("mkdir -p $temp_dir/dev/mapper");
 system("rsync -a --inplace /sys/block/dm* /sys/block/sd* $temp_dir/sys/block 2>/dev/null");
-system("rsync -a --inplace --exclude=chpd* /sys/devices/css0 $temp_dir/sys/devices 2>/dev/null"); 
-system("rsync -a --inplace /sys/devices/virtual/block/dm* $temp_dir/sys/devices/virtual/block 2>/dev/null"); 
-system("rsync -a --inplace /sys/class/fc_host /sys/class/scsi_device /sys/class/scsi_tape /sys/class/fc_remote_ports $temp_dir/sys/class 2>/dev/null");
+system("rsync -a --inplace --exclude=chpd* /sys/devices/css0 $temp_dir/sys/devices 2>/dev/null");
+system("rsync -a --inplace /sys/devices/virtual/block/dm* $temp_dir/sys/devices/virtual/block 2>/dev/null");
+system("rsync -a --inplace /sys/class/fc_host /sys/class/scsi_device /sys/class/scsi_tape /sys/class/scsi_generic /sys/class/fc_remote_ports $temp_dir/sys/class 2>/dev/null");
 store_mapper_devices($temp_dir,"/dev/mapper");
 system("tar -czf $out_file.cfg -C $temp_dir sys dev 2>/dev/null");
